package com.sec.android.app.shealth

import android.app.ActivityOptions
import android.app.Service
import android.content.ComponentName
import android.content.Intent
import android.os.*
import android.os.Process.THREAD_PRIORITY_BACKGROUND

class AppLauncherService : Service() {

    private var serviceLooper: Looper? = null
    private var serviceHandler: ServiceHandler? = null

    private inner class ServiceHandler(looper: Looper) : Handler(looper) {

        override fun handleMessage(msg: Message) {
            try {

                val intent = Intent()
                intent.setComponent(ComponentName("com.sec.android.app.shealth","com.sec.android.app.shealth.MainActivity"));
                val options = ActivityOptions.makeBasic().setLaunchDisplayId(1)
                intent!!.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)

                startActivity(intent, options.toBundle())

            } catch (e: InterruptedException) {
                Thread.currentThread().interrupt()
            }

            stopSelf(msg.arg1)
        }
    }

    override fun onCreate() {
        HandlerThread("ServiceStartArguments", THREAD_PRIORITY_BACKGROUND).apply {
            start()

            serviceLooper = looper
            serviceHandler = ServiceHandler(looper)
        }
    }

    override fun onStartCommand(intent: Intent, flags: Int, startId: Int): Int {
        serviceHandler?.obtainMessage()?.also { msg ->
            msg.arg1 = startId
            serviceHandler?.sendMessage(msg)
        }

        return START_STICKY
    }

    override fun onBind(intent: Intent): IBinder? {
        return null
    }
}